import { login, logout, getInfo, refreshToken ,tokenLogin} from '@/api/login'
import { getToken, setToken, setExpiresIn, removeToken } from '@/utils/auth'
import {deptTreeSelect,handsheDeptTreeSelect,businessTreeSelect,wholeTreeSelect} from "@/api/system/public";

const user = {
  state: {
    token: getToken(),
    name: '',
    userId: '',
    orgId:'',
    avatar: '',
    roles: [],
    roleList:[],
    permissions: [],
    orgName: '',
    //用户机构树
    orgTree: [],
    //行社机构树
    depTree: [],
    businessTree:[],
    wholeTree:[],
  },

  mutations: {
    SET_USERID: (state, userId) => {
      state.userId = userId
    },
    SET_TOKEN: (state, token) => {
      state.token = token
    },
    SET_EXPIRES_IN: (state, time) => {
      state.expires_in = time
    },
    SET_NAME: (state, name) => {
      state.name = name
    },
    SET_AVATAR: (state, avatar) => {
      state.avatar = avatar
    },
    SET_ROLES: (state, roles) => {
      state.roles = roles
    },
    SET_ROLELIST: (state, roleList) => {
      state.roleList = roleList
    },
    SET_ORG_ID: (state, orgId) => {
      state.orgId = orgId
    },
    SET_ORG_TYPE: (state, orgType) => {
      state.orgType = orgType
    },
    SET_PERMISSIONS: (state, permissions) => {
      state.permissions = permissions
    },
    SET_ORG_NAME: (state, val) => {
      state.orgName = val
    },
    SET_ORGTREE: (state, val) => {
      state.orgTree = val
    },
    SET_DEPTREE: (state, val) => {
      state.depTree = val
    },
    SET_BUSINESSTREE: (state, val) => {
      state.businessTree = val
    },
    SET_WHOLETREE: (state, val) => {
      state.wholeTree = val
    }
  },

  actions: {
    // 登录
    Login({ commit }, userInfo) {
      const username = userInfo.username.trim()
      const password = userInfo.password
      const code = userInfo.code
      const uuid = userInfo.uuid
      return new Promise((resolve, reject) => {
        let data = { username, password, code, uuid }
        login(data).then(res => {
          let data = res.data
          setToken(data.access_token)
          commit('SET_TOKEN', data.access_token)
          setExpiresIn(data.expires_in)
          commit('SET_EXPIRES_IN', data.expires_in)
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    TokenLogin({ commit }, token) {
      // const username = userInfo.username.trim()
      // const password = userInfo.password
      // const code = userInfo.code
      // const uuid = userInfo.uuid
      return new Promise((resolve, reject) => {
        tokenLogin(token).then(res => {
          let data = res.data
          setToken(data.access_token)
          commit('SET_TOKEN', data.access_token)
          setExpiresIn(data.expires_in)
          commit('SET_EXPIRES_IN', data.expires_in)
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // // 获取用户信息
    GetInfo({ commit, state }) {
      return new Promise((resolve, reject) => {
        getInfo().then(res => {
          const user = res.user;
          commit('SET_USERID', user.id)
          const avatar = (user.avatar == "" || user.avatar == null) ? require("@/assets/images/u29.svg") : user.avatar;
          if (res.roles && res.roles.length > 0) { // 验证返回的roles是否是一个非空数组
            commit('SET_ROLES', res.roles)
            console.log("SET_ROLES",res.roles);
            commit('SET_PERMISSIONS', res.permissions)
          } else {
            commit('SET_ROLES', ['ROLE_DEFAULT'])
          }
          if (res.roleList && res.roleList.length > 0) { // 验证返回的roles是否是一个非空数组
            commit('SET_ROLELIST', res.roleList)
          } else {
            commit('SET_ROLELIST', ['ROLE_DEFAULT'])
          }
          commit('SET_NAME', user.name)
          commit('SET_AVATAR', avatar)
          commit('SET_ORG_ID', user.orgId)
          commit('SET_ORG_NAME', user.orgName)
          commit('SET_ORG_TYPE', user.orgType)
          resolve(res)
        }).catch(error => {
          reject(error)
        })
      })
    },

    //获取机构、用户管理机构树
    getOrgTree({ commit, state }){
      return new Promise((resolve, reject) => {
        deptTreeSelect().then(res => {
          commit('SET_ORGTREE', res.data)
          resolve(res)
        }).catch(error => {
          reject(error)
        })
      })
    },

    //获取行社机构树
    getDepTree({ commit, state }){
      return new Promise((resolve, reject) => {
        handsheDeptTreeSelect().then(res => {
          commit('SET_DEPTREE', res.data)
          resolve(res)
        }).catch(error => {
          reject(error)
        })
      })
    },

    //获取业务机构树
    getBusinessTree({ commit, state }){
      return new Promise((resolve, reject) => {
        businessTreeSelect().then(res => {
          commit('SET_BUSINESSTREE', res.data)
          resolve(res)
        }).catch(error => {
          reject(error)
        })
      })
    },

     //获完整路径树（显示登录用户所在机构的所有下级以及直接上级机构）
     getWholeTree({ commit, state }){
      return new Promise((resolve, reject) => {
        wholeTreeSelect().then(res => {
          commit('SET_WHOLETREE', res.data)
          resolve(res)
        }).catch(error => {
          reject(error)
        })
      })
    },

    


    // 刷新token
    RefreshToken({commit, state}) {
      return new Promise((resolve, reject) => {
        refreshToken(state.token).then(res => {
          setExpiresIn(res.data)
          commit('SET_EXPIRES_IN', res.data)
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 退出系统
    LogOut({ commit, state }) {
      return new Promise((resolve, reject) => {
        logout(state.token).then(() => {
          commit('SET_TOKEN', '')
          commit('SET_ROLES', [])
          commit('SET_PERMISSIONS', [])
          removeToken()
          resolve()
        }).catch(error => {
          reject(error)
        })
      })
    },

    // 前端 登出
    FedLogOut({ commit }) {
      return new Promise(resolve => {
        commit('SET_TOKEN', '')
        removeToken()
        resolve()
      })
    }
  }
}

export default user
